

.include 	"tn13Adef.inc"		;  AtTiny13


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;  
.def	Temp6=R22			;   			
.def	Temp7=R23			;   		
.def	Temp8=R24			;   (4-, 1-)
.def	Temp9=R25


.dseg					; 

OZU: .byte 2				;  2   


;******************************************************************************


.cseg			

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

rjmp RESET				



.org ADCCaddr				; ADC Conversion Complete

rjmp ADC_2


.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00001000		;   "" (0-, 1-)
	out DDRB,Temp			; 000000 - "" 
					; 0000000 - ""   
					; 0000000 - ""  (ADC2)
				



	ldi Temp,0b00000000		;  !
	out PortB,Temp			; 




;_______________________________________________________________________________________________________________

	ldi Temp,(2<<MUX0)		
	out ADMUX,Temp	
					; REFS0=0 /   5V 
					; ADLAR=1 /   ( 8     2    )
					; MUX1=1 
					; MUX0=0 /   ADC2 ( PB4 )


	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIE)|(7<<ADPS0)
	out ADCSRA,Temp
					; ADEN=1 /  
					; ADSC=1 /   
					; ADATE=1 /  
					; ADIF=0 /      
					; ADIE=1 /    
					; ADPS2=1
					; ADPS1=1
					; ADPS0=1 /   1/128 ( 9,6  / 128 = 75  )



;	ldi Temp, (0<<ADTS0)
;	out ADCSRB,Temp
					; ACME=0 /      
					; ADTS2=0
					; ADTS1=0
					; ADTS0=0 /    (       )

;________________________________________________________________________________________________________________

	




	ldi Temp5,0			;   


	ldi Temp6,1			;    


	sei				;   
	

;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************


Main_cicle:



	cpi Temp5,1			;    ?	
	brne Main_cicle			;   ,  


	ldi Temp5,0			;   


	sbrc temp6, 0			;   ,   ,     
	rjmp opred_sevshiy_akkum	;    ,     

	rjmp obhod



;________________________________________________________________________________________
;       
;________________________________________________________________________________________

vozvrat:

	rcall zaderjka			; 



	mov tEMP2, temp7		;     
		
povtor:

	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  

	rcall zaderjka			; 

	dec temp2			;  " "   
	brne povtor



;_________________________________________________________________________________________
;        
;_________________________________________________________________________________________


obhod:					;        


	cpi Temp7, 4			;   4 ?
	brec esli_4


	cpi Temp7, 3			;   3 ?
	brec esli_3

	rjmp esli_2			;    2 

;_________________________________________________________________________________________
;      
;_________________________________________________________________________________________

indikaciya:				;      





	cpi Temp8, 4			;    4.0V    
	brec indic_esli_4


	cpi Temp8, 3			;    3.7V   4,0V    
	brec indic_esli_3


	cpi Temp8, 2			;    3.4V   3,7V    
	brec indic_esli_2


	rjmp indic_esli_1		;    3,4V    



;*****************************************************************************************
;     (  8V =  )
;*****************************************************************************************

opred_sevshiy_akkum:


	ldi Temp6,0			;    
					

	ldi Temp,0b00000001		; 8  = 0111100111
	ldi Temp1,0b11100111


	rcall compare			; ...

	breq bolshe_8_Volt		;     X=Z 
	brcs bolshe_8_Volt		;     X<Z
	rjmp menshe_8_Volt		;     X>Z 



;*****************************************************************************************
;     
;*****************************************************************************************

; (1)      (     )




bolshe_8_Volt:				;     (     )



	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  


	rjmp opred_kolich_banok		; 






;____________________________________________________________________________________________________
; (2)       (       )




menshe_8_Volt:				;     (       )


	Sbi PortB,5			;      "" -  



zavisanie:

	rjmp zavisanie			;  



;*****************************************************************************************
;    
;*****************************************************************************************

opred_kolich_banok:

	ldi Temp, 0b00000011		; 16,8  = 1111111111 ( 5    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_4bank			;     X=Z 
	brcs x_4bank			;     X<Z (   )
	rjmp x_3bank_op			;     X>Z 


x_4bank:


	ldi Temp7,4			;    = 4

	rjmp vozvrat


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


x_3bank_op:


	ldi Temp, 0b00000010		; 12,6  = 1011111111 ( 3,75    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_3bank			;     X=Z 
	brcs x_4bank			;     X<Z 
	rjmp x_2bank_op			;     X>Z 


x_3bank:

	ldi Temp7,3			;    = 3

	rjmp vozvrat


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

x_2bank_op:



	ldi Temp, 0b00000001		; 8,4  = 0111111111 ( 2,49    )
	ldi Temp1,0b11111111


	rcall compare			; ...

	breq x_2bank			;     X=Z 
	brcs x_3bank			;     X<Z 
	rjmp x_2bank			;     X>Z 


x_2bank:

	ldi Temp7,2			;    = 2

	rjmp vozvrat



;*****************************************************************************************
;    
;*****************************************************************************************

;  4 
;_____________

esli_4:



	ldi Temp, 0b00000011		; 4,0 V
	ldi Temp1,0b11001110


	rcall compare			; ...

	breq bolshe_40			;     X=Z 
	brcs bolshe_40			;     X<Z
	rjmp menshe_40			;     X>Z 


bolshe_40:


	ldi Temp8, 4			;   = 4

	rjmp indikaciya








menshe_40:


	ldi Temp, 0b00000011		; 3,7 V
	ldi Temp1,0b10000101


	rcall compare			; ...

	breq bolshe_37			;     X=Z 
	brcs bolshe_37			;     X<Z
	rjmp menshe_37			;     X>Z 


bolshe_37:


	ldi Temp8, 3			;   = 3

	rjmp indikaciya







menshe_37:


	ldi Temp, 0b00000011		; 3,4 V
	ldi Temp1,0b00111100


	rcall compare			; ...

	breq bolshe_34			;     X=Z 
	brcs bolshe_34			;     X<Z
	rjmp menshe_34			;     X>Z 


bolshe_34:


	ldi Temp8, 2			;   = 2

	rjmp indikaciya






menshe_34:


	ldi Temp8, 1			;   = 1

	rjmp indikaciya






;_____________
;  3 
;_____________

esli_3:


	ldi Temp, 0b00000010		; 4,0 V
	ldi Temp1,0b11011010


	rcall compare			; ...

	breq bolshe_40_3		;     X=Z 
	brcs bolshe_40_3		;     X<Z
	rjmp menshe_40_3		;     X>Z 



bolshe_40_3:


	ldi Temp8, 4			;   = 4

	rjmp indikaciya








menshe_40_3:


	ldi Temp, 0b00000010		; 3,7 V
	ldi Temp1,0b10100011


	rcall compare			; ...

	breq bolshe_37_3		;     X=Z 
	brcs bolshe_37_3		;     X<Z
	rjmp menshe_37_3		;     X>Z 



bolshe_37_3:


	ldi Temp8, 3			;   = 3

	rjmp indikaciya







menshe_37_3:


	ldi Temp, 0b00000010		; 3,4 V
	ldi Temp1,0b01101101


	rcall compare			; ...

	breq bolshe_34_3		;     X=Z 
	brcs bolshe_34_3		;     X<Z
	rjmp menshe_34_3		;     X>Z 



bolshe_34_3:


	ldi Temp8, 2			;   = 2

	rjmp indikaciya






menshe_34_3:


	ldi Temp8, 1			;   = 1

	rjmp indikaciya




;_____________
;  2 
;_____________

esli_2:


	ldi Temp, 0b00000001		; 4,0 V
	ldi Temp1,0b11100110


	rcall compare			; ...

	breq bolshe_40_2		;     X=Z 
	brcs bolshe_40_2		;     X<Z
	rjmp menshe_40_2		;     X>Z 



bolshe_40_2:


	ldi Temp8, 4			;   = 4

	rjmp indikaciya








menshe_40_2:


	ldi Temp, 0b00000001		; 3,7 V
	ldi Temp1,0b11000010


	rcall compare			; ...

	breq bolshe_37_2		;     X=Z 
	brcs bolshe_37_2		;     X<Z
	rjmp menshe_37_2		;     X>Z 



bolshe_37_2:


	ldi Temp8, 3			;   = 3

	rjmp indikaciya







menshe_37_2:


	ldi Temp, 0b00000001		; 3,4 V
	ldi Temp1,0b10011101


	rcall compare			; ...

	breq bolshe_34_2		;     X=Z 
	brcs bolshe_34_2		;     X<Z
	rjmp menshe_34_2		;     X>Z 



bolshe_34_2:


	ldi Temp8, 2			;   = 2

	rjmp indikaciya






menshe_34_2:


	ldi Temp8, 1			;   = 1

	rjmp indikaciya


;*****************************************************************************************
;     
;*****************************************************************************************

indic_esli_4:				;       4 




	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  

	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 


	rjmp Main_cicle			;  -         








;___________________________________________________________________________________________________
indic_esli_3:				;       3 




	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  

	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 
	rcall zaderjka			; 


	rjmp Main_cicle			;  -         


;___________________________________________________________________________________________________
indic_esli_2:				;       3 




	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  

	rcall zaderjka			; 
	rcall zaderjka			; 



	rjmp Main_cicle			;  -         




;__________________________________________________________________________________________________
indic_esli_1:				;       3 




	Sbi PortB,5			;      "" -  

	rcall zaderjka			; 

	cbi PortB,5			;      "" -  



	rjmp Main_cicle			;  -         


;*****************************************************************************************
;   
;*****************************************************************************************

zaderjka:


	ldi Temp,255			;  

	ldi Temp1,255			

delay_256:
	
	dec Temp
	brne delay_256

	dec Temp1
	brne delay_256


	ret

;*****************************************************************************************
;   
;*****************************************************************************************


compare:

	cp Temp,ZH			;    
	breq xh_eq_Zh			;    ,    Xl  Zl
					;   -   X<Z
					;   -   X>Z
	ret



xh_eq_Zh:

	cp Temp1,ZL			;    
					;  Z=1  X=Z
					;   -   X<Z
					;   -   X>Z

	ret      


;*********************************************************************************************************************************
;  
;*********************************************************************************************************************************

ADC_2:

	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4


	ldi Temp5,1			;   



	in zl,ADCL			;     "z"  "ADCH"  "ADCL"
	in zh,ADCH 



	ANDI zh,0b00000011		;  (     ?    ? )???????????????????????????????????????????????????????????????

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4


	reti



;**************************************************************************************************************









	

